package ovh.herisson.Clyde.Services;

import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import ovh.herisson.Clyde.Repositories.TokenRepository;
import ovh.herisson.Clyde.Tables.Token;
import ovh.herisson.Clyde.Tables.User;

import java.nio.charset.StandardCharsets;
import java.security.SecureRandom;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

@Service
public class TokenService {

    TokenRepository tokenRepo;

    public TokenService(TokenRepository tokenRepo){
        this.tokenRepo = tokenRepo;
    }


    public String generateNewToken(){
        byte[] bytes = new byte[64];
        new SecureRandom().nextBytes(bytes);
        String token = new String(bytes, StandardCharsets.US_ASCII);
        System.out.println(token);
        return token;
    }

    public User getUserFromToken(String token){
        return tokenRepo.getByToken(token).getUser();
    }

    public void saveToken(Token token){
        //Si l'utilisateur a déja 5 token delete celui qui devait expirer le plus vite
        ArrayList<Token> tokenList = tokenRepo.getByUserOrderByExpirationDate(token.getUser());
        if (tokenList.size() == 5){
            tokenRepo.delete(tokenList.get(0));
        }
        tokenRepo.save(token);
    }

    //Tous les jours a minuit
    @Scheduled(cron = "0 0 0 * * ?")
    public void autoDeleteToken() {
        for (Token t: tokenRepo.findAll()){
            Calendar cal = Calendar.getInstance();
            cal.setTime(new Date());

            Calendar cal2 = Calendar.getInstance();
            cal2.setTime(t.getExpirationDate());
            if (cal.get(Calendar.YEAR) == cal2.get(Calendar.YEAR) && cal.get(Calendar.DAY_OF_YEAR) == cal2.get(Calendar.DAY_OF_YEAR)){
                tokenRepo.delete(t);
            }
        }
    };
}